# encoding: utf-8
# n番目までの一連のベルヌーイ数を算出：随時算出方式

# 組み合わせパターン数(二項係数)を算出
def nck(n, k)
    kk = (1..k).to_a  # 1, 2, 3, …… k を配列にする
    c = Rational(1)
    for i in (n-k+1)..n
        c *= i
        c /= kk.pop
    end
    return c.to_i
end

# n番目までの一連のベルヌーイ数を算出
def bern1(num)
    bn = []  # この配列にベルヌーイ数を入れる
    bn[0] = 1
    for n in 1..num
        s = Rational(0)
        for i in 0..(n-1)
            s = s + nck(n+1, i) * bn[i]
        end
        bn[n] = -Rational(1, n+1) * s
    end
    return bn
end

# テスト表示
bn = bern1(30)  # B0〜B30 を取得
for i in 0..30
    next  if bn[i] == 0  # ベルヌーイ数が0ならスキップ
    printf("B%d: %s\n", i, bn[i])
end
