# encoding: utf-8
# n番目のベルヌーイ数を算出：直接算出方式

# 組み合わせパターン数(二項係数)を算出
def nck(n, k)
    kk = (1..k).to_a  # 1, 2, 3, …… k を配列にする
    c = Rational(1)
    for i in (n-k+1)..n
        c *= i
        c /= kk.pop
    end
    return c.to_i
end

# n番目のベルヌーイ数を算出
def bern2(num)
    bn = Rational(0)  # 最終的にこれにベルヌーイ数が入る
    for k in 0..num
        elm1 = (-1)**k  # (-1)^k
        elm2 = k**num  # k^num
        elm3 = Rational(0)  # 以下の総和をこれに代入
        for n in k..num
            elm3 = elm3 + Rational(1, n+1) * nck(n, k)
        end
        bn = bn + elm1 * elm2 * elm3
    end
    return bn
end

# テスト表示
for i in 0..30
    bn = bern2(i)
    next  if bn == 0
    printf("B%d: %s\n", i, bn)
end
