# encoding: utf-8
# x/(e^x - 1) からベルヌーイ数を得る
require "./binomer"

max = 16  # 無限級数を何項まで扱うかの数
es = Binomer::e(max)  # e^x の展開式
w = (es - 1) / "x"  # (e^x - 1) / x
bs = w.reciprocal(max)  # 逆数をとり  x / (e^x - 1)  を得る
printf("'x/(e^x-1)':\n%s\n\n", bs.cx.join(" + "))  # x/(e^x-1) を表示
bn = []  # この配列にベルヌーイ数を入れる
while a = bs.first  # 初項の情報を取得
    if a[2] >= 1 then  # 定数項がない(x^0がなく xの指数が1以上)
        bn << 0  # ベルヌーイ数は０
    else  # 定数項があるので
        bn << a[0]  # 定数項をベルヌーイ数として記録
    end
    bs = bs.differential  # 級数を微分する
end

puts "'Bernoulli number':"
for i in 0...bn.size
    next  if bn[i] == 0
    printf("B%d: %s\n", i, bn[i])
end
